/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <hdb/db.h>

static fp_stream merr(stderr);

main(int argc,char* argv[]) throw(merror_t) try
{
  if(argc<2) {
    merr<<"Usage: "<<argv[0]<<" <path>\n";
    return -1;
  }
  dbmap m;
  m.Open(argv[1]);

  merr<<m.head()->filesize.get()<<"\n";
  merr<<m.head()->filetop.get()<<"\n";
  merr<<m.head()->frame.get()<<"\n";
  
  for(int j=0;j<m.Tables();j++) merr<<m.Table(j)<<" ";
  merr<<"\n\n";

  for(int i=0;i<m.size();i++) {
    //for(int j=0;j<m.Tables();j++) merr<<m(i,j)<<" ";
    for(int j=0;j<1;j++) merr<<m(i,j)<<" ";

    merr<<"\n";
  }

  return 0;
}
catch(const merror_t& e) {
  merr<<e.desc<<"\n";
  return -1;
}
