/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef EDITH
#define EDITH

#include <mt/mstring.h>

struct Editor {
  static const int MAXLINES=1024;
  static const int MAXCOLS=256;
  struct Line {
    Line();
    Line(char* p,int s);
    ~Line();
    int Insert(int pos,char c);
    int Append(const Line* p);
    Line* Break(int pos);
    void Delete(int pos);
    char* line;
    int dim;
  };

  Editor(const mstring& path,int ex);
  ~Editor();

  void Copy(mstring& s);
  void Paste(const mstring& s);

  void Show();
  void Home();
  void Move(int i,int j);
  void Navigate();
  void Insert(int c);
  void BreakLine();
  void Delete();
  void Backspace();

  mstring path,caption;
  Line* map[MAXLINES];
  int from,lines,atline,size;
  int tab,cols,atcol,exclusive;
};

#endif
