/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef TABLESH
#define TABLESH

#include <hed/edit.h>
#include <hdb/db.h>

struct Tables {
  Tables();
  ~Tables();

  void Open(const mstring& path,int ex=0);
  void Save();
  void Close();

  void Setup(int sp);

  void Show();
  void Home();
  void Move(int i,int j);
  void Navigate();
  int Command();

  void Sort();
  void Order();
  void Check();

  void Edit();
  void Insert();
  void Delete();
  void FileName();
  void AddTable();
  void RemTable();
  void Help();

  dbmap db;
  mstring path,caption;
  int from,lines,atline,writable;
  int tab,space,cols,dispcols,dim,atcol;
  int lastfrom,lasttab,lastline,lastcol;
};

#endif
