c*****************************************************************
c*****************************************************************
c*****************************************************************
c                             GGA 
c        The Generalized Gradient Approximation

c  GGA is a way to improve the local spin density approximation
c  by adding nonlocal gradients in the evaluation of the exchange-
c  correlation energy and potential. These functions and subroutines 
c  are based on programs made by John Perdew, Tulane University,
c  New Orleans, Louisiana, USA. Email: PY03APF%music.tcs.tulane.edu
c  The modifications necessary to fit them to the atom program was
c  made by Tomas Holmquist 1993 (so now you know who to blame). 
c  Email: tomash@fy.chalmers.se
c  A more thorough description of the GGA used may be found in 
c  J.P. Perdew et al, Phys. Rev. B  (46) 1992 pp. 6671-6687.

c  The GGA package is:

c         function deriv
c         subroutine grad
c         subroutine grabgr
c         subroutine laplac
c         subroutine spline
c         subroutine splint
c     subroutine ggaexc
c         subroutine exchen
c         subroutine ldaec
c         subroutine gcor
c         subroutine ggaec
c     subroutine ggauxc
c         subroutine exchpt
c         subroutine ldauc
c         subroutine ggauc

c  The grad, grabgr, and laplace subroutines uses the function deriv
c  to calculate different derivatives with respect to the radial 
c  coordinate r. Spline and splint calculates the cubic spline 
c  interpolation which is used in function deriv.
c  The two main subprograms, ggaexc and ggauxc, calculates
c  the exchange-correlation energy and potential respectively.
c  The other subroutines are modified versions of Perdew's program.

c*****************************************************************
c*****************************************************************
