/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <lang/env.h>

static fp_stream mout(stdout),merr(stderr);

main(int argc,char* argv[]) try
{
  Lang lang;
  req_env req(lang,lang.toks);
  Env env(lang.ops,req,XSYSTEM);
  mstring line;
  while(!feof(stdin)) {
    merr<<"lang>";
    getline(line,stdin);
    try {
      env.parse(mout,line);
      mout<<"\n";
    }
    catch(const merror_t& e) {
      merr<<e.desc<<"\n";
    }
  }
  return 0;
}
catch(const merror_t& e) {
  merr<<"ERROR: ["<<e.desc<<"]\n";
}
