/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef MAILBOXH
#define MAILBOXH

#include <mime/mime.h>
#include <mt/dates.h>

const mstring from_tag="From";
const mstring to_tag="To";
const mstring subject_tag="Subject";
const mstring msgid_tag="Message-ID";
const mstring received_tag="Received";

class Message : public Mime {
public:
  Message();
  Message(const sref& msg) { Init(msg); }

  mstring from0,from,date,subject,to,msgid;
  spile received;
  time_t idate;

  void putHead(mstream& out) const;
protected:
  int Special(sref line);
  int Handle(const sref& name,
             const sref& rawval,
             const sref& val,
             const rrpile& opts);
};

typedef msvec<mstring> Mailbox;

void AppendMessage(FILE* fp,const sref& msg);
void AppendMessages(FILE* fp,const Mailbox& box);

int PutMessages(const Mailbox& box,const mstring& path);
int AppendMessages(const Mailbox& box,const mstring& path);

int GetMessages(Mailbox& box,const mstring& path);

#endif
