/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef DATESH
#define DATESH

#include <mt/mstring.h>
#include <time.h>

const time_t SEC_PER_DAY=86400;
const int MAXLANG=2;
const mstring LANG[MAXLANG]={"en","sv"};

inline time_t Now() { return time(0); }
inline time_t Days(int days) { return days*SEC_PER_DAY; }

time_t Today(time_t);
time_t Sunday(time_t);

const mstring& Week(int lang,time_t t);
const mstring& Month(int lang,time_t t);

const mstring& SWeek(int lang,time_t t);
const mstring& SMonth(int lang,time_t t);

mstring httpTime(time_t t);
mstring htcTime(int lang,time_t t);
time_t htcTime(int lang,const sref& date);
time_t cvtTime(const sref& code);

int Language(const sref& s);

#endif
