/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ISSUEH
#define ISSUEH

#include <mt/mstring.h>
#include <mt/mvec.h>
#include <mt/split.h>

// ISSUE A PIPED COMMAND
//
// This class is tuned to work in a mt environment.
// The aim is to make this work locally as if it was
// a single thread returning something to the stream out
// depending on the input in.

struct issue_t {
  mrvec<char*> arg;

  issue_t() {}
  ~issue_t() { clear(); }

  issue_t(const sref& s,const charset& ws=cset_ws) {
    sref first,rest=s;
    while(Split(first,rest,ws)) arg.push_back(first.news());
    arg.push_back(0);
  }

  void clear() { for(int i=0;i<arg.size();i++) delete arg[i]; arg.clear(); }
  void add(const sref& s) { arg.push_back(s.news()); }
  void end() { arg.push_back(0); }
  char* const* argv() const { return arg.begin(); }

  void run(mstream& out,const sref& in) throw(merror_t);
};

#endif

