/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <mt/mset.h>
#include <algorithm>
using namespace std;

mset::mset() : rpile() {}
mset::mset(const sref& in) : rpile() {
  sref first,rest=in;
  while(Split(first,rest)) insert(first);
}

/////////////////////////////////////////////////////////////////////////////

int mset::exist(const sref& t) const {
  pair<const_iterator,const_iterator> p=equal_range(begin(),end(),t);
  return p.first!=p.second;
}
int mset::insert(const sref& t) {
  pair<iterator,iterator> p=equal_range(begin(),end(),t);
  if(p.first==p.second) { rpile::insert(p.second,t); return 1; }
  else return 0;
}

/////////////////////////////////////////////////////////////////////////////

void mset::Union(const mset& a,const mset& b) {
  clear();
  for(int i=0;i<a.size();i++) insert(a[i]);
  for(int i=0;i<b.size();i++) insert(b[i]);
}
void mset::Intersection(const mset& a,const mset& b) {
  clear();
  for(int i=0;i<a.size();i++) if(b.exist(a[i])) insert(a[i]);
}
void mset::Difference(const mset& a,const mset& b) {
  clear();
  for(int i=0;i<a.size();i++) if(!b.exist(a[i])) insert(a[i]);
}

/////////////////////////////////////////////////////////////////////////////

mstream& operator<<(mstream& out,const mset& m) {
  for(int i=0;i<m.size();i++) { if(i) out.put(' '); out<<m[i]; } return out;
}

/////////////////////////////////////////////////////////////////////////////

int msset::exist(const mstring& t) const {
  pair<const_iterator,const_iterator> p=equal_range(begin(),end(),t);
  return p.first!=p.second;
}
int msset::insert(const mstring& t) {
  pair<iterator,iterator> p=equal_range(begin(),end(),t);
  if(p.first==p.second) { spile::insert(p.second,t); return 1; }
  else return 0;
}

/////////////////////////////////////////////////////////////////////////////

mstream& operator<<(mstream& out,const msset& m) {
  for(int i=0;i<m.size();i++) { if(i) out.put(' '); out<<m[i]; } return out;
}

