/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef MSETH
#define MSETH

#include <mt/split.h>
#include <mt/mstring.h>
#include <mt/mvec.h>

typedef mrvec<sref> rpile;

struct mset : public rpile
{
  typedef rpile::iterator iterator;
  typedef rpile::const_iterator const_iterator;
  
  mset();
  mset(const sref& in);

  int exist(const sref& t) const;
  int insert(const sref& t);

  void Union(const mset& a,const mset& b);
  void Intersection(const mset& a,const mset& b);
  void Difference(const mset& a,const mset& b);
};

mstream& operator<<(mstream& out,const mset& m);

//////////////////////////////////////////////////////////

typedef msvec<mstring> spile;

struct msset : public spile
{
  typedef spile::iterator iterator;
  typedef spile::const_iterator const_iterator;

  int exist(const mstring& t) const;
  int insert(const mstring& t);
};

mstream& operator<<(mstream& out,const mset& m);

#endif
