/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <mt/uniheap.h>
#include <mt/stackque.h>
#include <mt/random.h>
#include <mt/lookup.h>
#include <mt/mset.h>
#include <mt/issue.h>
#include <mt/mvec.h>
#include <mt/msmap.h>
#include <time.h>

#define GENERAL 0
#define STREAM 1
#define HEAPS 0
#define CHARSET 0
#define RANDOM 0
#define LOOKUP 0
#define ISSUE 1
#define MSET 0
#define CVTS 0
#define VECTOR 0
#define MSMAP 0

static fp_stream mout(stdout),merr(stderr);

main(int argc,char* argv[])
{
  mstring s;
#if GENERAL
  s="asdfwerfindfindis?? asdf wert nnvnbn\n";

  mout<<"["<<Trim(s,cset_para)<<"]\n";

  sref find=sref("find");
  sref rfind=sref("rfind");

  mout<<s.find(find)<<"\n";
  mout<<s.rfind(rfind)<<"\n";
  mout<<s.find(find,cset_lcase)<<"\n";
  mout<<s.rfind(rfind,cset_lcase)<<"\n";
  mout<<s.find(find,cset_ucase)<<"\n";
  mout<<s.rfind(rfind,cset_ucase)<<"\n";

  mout<<"****\n";

  mout<<"["<<s.leftand_last_not_of(cset_ws)<<"]\n";

  mout<<"****\n";

  s.tolower();
  mout<<"["<<s<<"]\n";
  s.toupper();
  mout<<"["<<s<<"]\n";

  mout<<"*****\n";

  mstring st="abcdefghi2jklmn";
  charset stset("123");
  mout<<"["<<st.left_first_of(stset)<<"]\n";
  mout<<"["<<st.right_first_of(stset)<<"]\n";
  mout<<"["<<st.past_first_of(stset)<<"]\n";

  mout<<"******\n";

  mstring a=First(s);
  mstring b=Rest(s);
  mstring c=Last(s);
  mout<<"["<<a<<"]\n";
  mout<<"["<<b<<"]\n";
  mout<<"["<<c<<"]\n";

  mout<<"******\n";

  sref first,rest=s;
  while(Split(first,rest)) {
    mout<<"["<<first<<"]["<<atoi(first)<<"]\n";
  }

  mout<<"*******\n";

  mout<<"["<<mstring().convert("%d %02X",56,100)<<"]\n";

  mout<<s.skip(cset_para)<<"\n";

  mout<<"********\n";

  //mstring buf; buf.load("tt.cc");
  //mout<<"***\n"<<buf<<"***\n";
#endif
#if STREAM
  s="more strange asdf\n";

  swrite to;
  mout<<s<<"\n";
  to.hold(s)<<" Hello! this is appending "<<4<<" to string\n";
  mout<<s<<"\n";

  mout<<"********\n";

  mstream mm; mm<<"Hejsan!\n";

  mout<<"********\n";

  try {
    THROW("hello "<<4<<" once more");
  }
  catch(const merror_t& e) {
    mout<<"Error test: "<<e.num<<"\n";
    mout<<e.desc<<"\n";
  }

  mout<<"********\n";

  sref sa=s;
  sref sb=s;
  mout<<(sa==sb)<<"\n";

  mout<<"********\n";
  
  mstring tt="(asdf)sdfsdf";
  mout<<tt.skip(cset_para)<<"\n";
  mout<<"["<<tt(1,tt.skip(cset_para)-2)<<"]\n";

  mout<<"********\n";
#endif

#if HEAPS

  uniheap<4> stack; stack.init();
  for(int i=0;i<48;i++) {
    //stack.pop(stack.push());
    stack.push();
  }
  mout<<"--\n";
  mout<<stack.chunksize()<<"\n";

  mout<<"********\n";

  stackque<int> que(8);
  for(int i=0;i<8;i++) que.push(i);

  try {
    que.push(5);
  }
  catch(const merror_t& e) {
    merr<<e.num<<"\n";
    merr<<e.desc<<"\n";
  }

  int pop;
  while(que.pop(pop)) merr<<pop<<"\n";
  
#endif

#if CHARSET

  charset set("12345d");
  charset set2("12");
  charset set3=set-set2;
    
  merr<<"* \n";

  for(int i=-127;i<127;i++) {
    if(set.map[i]) mout<<i<<"("<<char(i)<<")\n";
  }

  merr<<"* \n";

  for(int i=-127;i<127;i++) {
    if(set3.map[i]) mout<<i<<"("<<char(i)<<")\n";
  }

  merr<<"**\n";

  mout<<find_of_("",1,set.map)<<"\n";
  mout<<s.find_of(set)<<"\n";

  mout<<"***\n";

  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_lcase[i]!=i) mout.put(i);
  mout<<"]\n";
  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_lcase[i]!=i) mout.put(cset_lcase[i]);
  mout<<"]\n";

  mout<<"\n";

  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_ueqv1[i]!=i) mout.put(i);
  mout<<"]\n";
  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_ueqv1[i]!=i) mout.put(cset_ueqv1[i]);
  mout<<"]\n";

  mout<<"\n";

  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_ueqv2[i]!=i) mout.put(i);
  mout<<"]\n";
  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_ueqv2[i]!=i) mout.put(cset_ueqv2[i]);
  mout<<"]\n";

  mout<<"\n";

  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_sim[i]!=i) mout.put(i);
  mout<<"]\n";
  mout<<"[";
  for(int i=-127;i<128;i++) if(cset_sim[i]!=i) mout.put(cset_sim[i]);
  mout<<"]\n";
#endif

#if RANDOM
  RandomInit(13);
  for(int i=0;i<100;i++) mout<<Uniform()<<"\n";
#endif

#if LOOKUP

  while(1) {
    mstring ip;
    merr<<"addr>";
    getline(ip,stdin);
    IPnode node;
    for(int i=0;i<4;i++) {
      if(Lookup(node,ip)) {
        merr<<node.valid<<"\n";
        merr<<node.ip<<"\n";
        merr<<node.name<<"\n";
      }
      else {
        merr<<"Not found\n";
        break;
      }
    }
  }
    
#endif

#if ISSUE

  issue_t cmd(sref("/bin/cat"));
  mswrite out;
  mstring in="hello world!";
  cmd.run(out,in);
  mout<<"Got ["<<out.str()<<"]\n";

  cmd.clear();
  cmd.add(sref("sadfasfd"));
  cmd.end();
  out.clear();
  cmd.run(out,in);
  mout<<"Got ["<<out.str()<<"]\n";

#endif

#if MSET

  mstring mm="hello world!\n how many items?\n";
  mset a=mm;
  for(int i=0;i<a.size();i++) {
    mout<<a[i]<<"\n";
  }

  mout<<"OR ["<<a<<"]\n";

#endif

#if CVTS

  merr<<"n: "<<itoa(5)<<"\n";
  merr<<"f: "<<ftoa(5)<<"\n";
  merr<<"f: "<<ftoa(5.7)<<"\n";
  merr<<"f: "<<ftoa(-3)<<"\n";
  merr<<"f: "<<ftoa(3.78678)<<"\n";
  merr<<"f: "<<ftoa(exp(2.1))<<"\n";
  merr<<"f: "<<ftoa(time(0))<<"\n";
  merr<<"direct: "<<3.40000<<"\n";

  pipe_stream tout(1);
  tout<<"How does this one "<<-78.4<<" behave??\n";

  mstring inp;
  getline(inp,stdin);
  merr<<ftoa(atof(inp))<<"\n";

#endif

#if VECTOR

  mrvec<int> v(4);
  for(int i=0;i<v.size();i++) v[i]=i;

  for(int i=0;i<v.size();i++) merr<<v[i]<<"\n";

#endif

#if MSMAP

  ssmap map;
  //map.add("hello","world");
  //map.add("one","world!");
  map.push_back(sstring("one","world!"));
  map.push_back(sstring("hello","world"));
  map.sort();

  for(ssmap::iterator p=map.begin();p!=map.end();p++) {
    merr<<p->first<<" "<<p->second<<"\n";
  }

  const mstring* p=map.get("one");
  if(p) merr<<"got "<<*p<<"\n";

#endif

  return 0;
}
