/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <net/isocket.h>
#include <mt/lookup.h>
#include <sys/utsname.h>

static fp_stream merr(stderr);
static IPnode NODE;
static mstring PATH;
static int PORT;

const int BACKLOG=4;
const int SNDBUFSIZE=16384;
const int RCVBUFSIZE=16384;

///////////////////////////////////////////////////////////////

static void MainProc(isocket& sock)
{
  int fd=dup2(sock.fd,0);
  if(fd!=0) { merr<<"Not right\n"; return; }
  execl("htcd","htcd",PATH.c_str(),"-1",0);
}

///////////////////////////////////////////////////////////////

static void httpServer()
{
  isocket sock(NODE.addr,PORT,BACKLOG);
  sock.keepalive(1);
  sock.sendbufsize(SNDBUFSIZE);
  sock.recvbufsize(RCVBUFSIZE);
  MainProc(sock);
}

main(int argc,char* argv[])
{
  if(argc<3) { merr<<"Usage: "<<argv[0]<<" <path> <port>\n"; return -1; }
  PATH=argv[1]; if(PATH.back()=='/') PATH=PATH.popb();
  PORT=atoi(argv[2]);
  struct utsname u; uname(&u);
  Lookup(NODE,sref(u.nodename));
  httpServer();
  return 0;
}


