/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef NNSTYLEH
#define NNSTYLEH

#include <mt/split.h>

const charset cset_wsdot=cset_ws|'.';

inline mstring nncase(const sref& b)
{
  static const mstring comma_tag(","),and_tag("and");
  mstring acc,a,name;
  sref next,first,rest=b;
  while(Split(first,rest,cset_wsdot)) {
    if(first==comma_tag||eqn(first,and_tag)) continue;
    (name=first.left_first(comma_tag)).tosim();
    name[0]=cset_ucase[name[0]];
    next=First(rest);
    if(first.back()==','||next.empty()||*next==','||eqn(next,and_tag)) {
      a.insert(0,name);
      if(acc.nempty()) { acc+=' '; acc+=and_tag; acc+=' '; }
      acc+=a;
      a.clear();
    }
    else { a+=' '; a+=name[0]; a+='.'; }
  }
  return acc;
}

inline int nncomp(const sref& L,const sref& R)
{
  return nncase(L).compare(nncase(R));
}

#endif
