/*************************************************************************
 *
 * HTCd - Copyright (C) 1998-2006 Henrik Rydberg
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef TEMPMAPH
#define TEMPMAPH

#include <sh/htc.h>

const mstring TEMP_tag="TEMP";

const int temp_tabs=5,temp_id=0,temp_name=1,temp_start=2,temp_stop=3;
const mstring temp_tab[temp_tabs]={
  "ID","NAME","START","STOP","REFER"
};

struct tempmap_t {
  spile list;
  
  tempmap_t() : list(temp_tabs) { reset(); }
  
  mstring& id() { return list[0]; }
  mstring& name() { return list[1]; }
  mstring& start() { return list[2]; }
  mstring& stop() { return list[3]; }
  mstring& refer() { return list[4]; }

  void reset() {
    list.resize(temp_tabs);
    id()=itoa(0);
    name().clear();
    start()=itoa(0);
    stop()=itoa(0);
    refer()=itoa(0);
  }
};

/////////////////////////////////////////////////////////

void envAddTemp(tokmap& T);

#endif
